import { FC, useEffect, useState } from "react";
import QRCodeInternal from "react-qr-code";
import { Box } from "@mui/material";
import { colors } from "../styles/theme";

type QRCodeProps = {
  name: string;
  label: string;
  token: string;
  verified: boolean;
  helperText?: string;
  getValue?: (id: string) => Promise<Record<string, string>>;
  refreshInterval?: number;
};

export const QRCode: FC<QRCodeProps> = ({
  name,
  label,
  token,
  verified,
  helperText,
  getValue,
  refreshInterval,
}) => {
  const [value, setValue] = useState("");
  const [kind, setKind] = useState("data");
  const { white } = colors;

  useEffect(() => {
    if (!verified && getValue && refreshInterval) {
      const interval = setInterval(async () => {
        const { qr, kind } = await getValue(token);
        console.log({ kind });
        setValue(qr);
        setKind(kind);
      }, refreshInterval * 1000);
      return () => clearInterval(interval);
    }
  }, [getValue, refreshInterval]);

  return !verified ? (
    <Box sx={{ backgroundColor: white, m: 2 }}>
      {kind === "data" ? (
        <QRCodeInternal value={value} />
      ) : (
        <img src={value} alt={name} />
      )}
      <Box>{helperText}</Box>
    </Box>
  ) : null;
};
